#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;

#print "Content-type: text/html\n\n";

&get_setup;
fmspm::check_spamb("click2.cgi", "header", "$data_dir");
$q = CGI->new;

$referer = $ENV{'HTTP_REFERER'};

#if ($referer eq ""){print "Location: $web_url/noref.gif\n\n"; exit;}

$gid = $q->param('grp');
$gid =~ s/[^0-9]//g;

$pg = $q->param('pg');
$pg =~ s/[^0-9]//g;

if ($gid eq ""){&berror("Invalid Banner Group.");}
if ($pg eq ""){&berror("Invalid Banner Code. Please re-insert banner code.");}



$current_time = time();
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$year = $year + 1900;
$mon++;

$lfilename = $gid . "_" . $year . $mon . $mday . ".tdy";



### REMOVE OLD REFERER LOGS

opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 4, 4) eq ".tdy")
			{
			
			($device1,$inode1,$mode1,$nlink1,$uid1,$gid1,$rdev1,$size1,$atime1,$mtime,$ctime1,$blksize1,$blocks1) = lstat("$data_dir/$filename");

			#$year1=0;
			#($sec1,$min1,$hour1,$mday1,$mon1,$year1,$wday1,$ydat1,$isdst1) = localtime($mtime);
			#$year1 = $year1 + 1900;
			
			if (($mtime +  259200) < $current_time) {  unlink ("$data_dir/$filename"); }
			
			}
		}




### GET BANNER ID OF CLICKED BANNER

opendir(DIR,"$data_dir");
	@files2 = readdir(DIR);
	foreach $filename (@files2)
		{
			if (substr($filename, length($filename) - 4, 4) eq ".tdy") 
			{
			
				($f_gid, $tmp) = split (/_/, $filename);
				$substr_length = length($f_gid);
				
			  if (substr($filename, 0, $substr_length) eq $gid)
				{
					open (REFT, "$data_dir/$filename");
					 my @bloglines = <REFT>;
					close (REFT);
					push (@reflines, @bloglines);
				}
			}
		
		}


### GO THROUGH LOG LINES TO GET BANNER ID

$cip = $ENV{'REMOTE_ADDR'};

$lcnt = @reflines;

for ($ms = 0; $ms < $lcnt; $ms++) 
	{ 
	($time, $pg_log, $ip, $bid) = split (/\t/, $reflines[($lcnt-1) - $ms]);

#		if (($pg_log eq $pg) and ($ip eq $cip) and ($true_bid eq ""))
		if (($pg_log eq $pg) and ($true_bid eq ""))
			{
			$true_bid = $bid;
			}
	}




### IF DEFAULT BANNERS FROM DEFAULT BANNER GROUP WAS DISPLAYED

if ($true_bid eq "")
	{
	$defaultb = pseek::get_file_contents("$data_dir/defaultb.dat"); 
	($defaultb, $dname) = split(/-/, $defaultb);
	
		opendir(DIR,"$data_dir");
			@files3 = readdir(DIR);
			foreach $filename (@files3)
				{
					if (substr($filename, length($filename) - 4, 4) eq ".tdy") 
					{
				
						($f_gid, $tmp) = split (/_/, $filename);
						$substr_length = length($f_gid);
				
					  if (substr($filename, 0, $substr_length) eq $defaultb)
						{
							open (REFT, "$data_dir/$filename");
							 my @bloglines2 = <REFT>;
							close (REFT);
							push (@reflines, @bloglines2);
						}
					}
		
				}


	$lcnt = @reflines;

	for ($ms = 0; $ms < $lcnt; $ms++) 
		{ 
		($time, $pg_log, $ip, $bid) = split (/\t/, $reflines[($lcnt-1) - $ms]);
	
			#if (($pg_log eq $pg) and ($ip eq $cip) and ($true_bid eq ""))
			if (($pg_log eq $pg) and ($true_bid eq ""))
				{
				$true_bid = $bid;
				}
		}
	}




### IF NO TARGET COULD BE FOUND

if ($true_bid eq "")
	{

	print "Content-type: text/html\n\n";
	print qq[
			<html>
			<head>
			<title>Problem</title>
			</head>
			<body>
			<b>
			<p>Could not find target.</b></p>
			<p>No banner group matching click criteria could be found.<br>
			<br>
			Please assign a 'Default' banner group so that default banners can be displayed when
			banners cannot be displayed from specified group. (Due to expiry or number of impressions
			reached) </p>
			<p>This error can also be caused by using incorrect banner code. If this is the case then
			re-insert the banner code in the previous page.</p>
			</body>
			</html>
			];
			exit;
	}







### GET BANNER LINK

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT bname, image, link, weight, bid FROM banners WHERE bid = '$true_bid'";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$bstringc = 0;
while ( @row = $sth->fetchrow() )
	{
	$link = $row[2];
	}



###### RECORD CLICK

$current_time = time();
($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
$year = $year + 1900;
$mon++;

if (length($mon) == 1) { $mon = "0" . $mon; }
if (length($mday) == 1) { $mday = "0" . $mday; }
$stat_date = $year . "-" . $mon . "-" . $mday;

$sql = "UPDATE balogs SET clicks = (clicks + 1) WHERE (statdate = '$stat_date') AND (groupid = '$gid') AND (bid = '$true_bid')";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
$rows = $sth->rows();


if ($rows > 0)
	{
	$sql = "UPDATE bannergrp SET current_clc = (current_clc + 1) WHERE (groupid = '$gid')";
	
	#open (ERRORLOG, "> $data_dir/tmp.tmp");
	#	print ERRORLOG "$sql";
	#close (ERRORLOG);

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
	$rows = $sth->rows();
	}

$sth->finish;
$dbh->disconnect;

#print "Content-type: text/html\n\n";
#print "==> $referer <br><br>";
#print "LOGID: $logid <br><br>$sql<br><br>";
#print "===> $stat_date <br>";


#print "Location: $link\n\n";


print "Content-type: text/html\n\n";
print qq[
<html>
<head>
<title>Redirecting</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$link">
</head>
<body>
</body>
</html>
];






sub berror
{
my ($theprob) = @_;

print "Content-type: text/html\n\n";
print $theprob;

exit;

}


############

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################




sub getCookies
{

	$temp2 = $ENV{'HTTP_COOKIE'};
	
	@rawCookies = split (/; /,$temp2);
	
	foreach $item2(@rawCookies)
	{
		($key, $val) = split (/=/,$item2,2);
		
		if ($cookies{$key} eq "")
			{
			$cookies{$key} = $val;
			}
	}
	
}
 